unit Demo_unit;
// To add support for a non-standard graphics file-format, simply add the unit
// to the uses clause of your program - below I have the unit 'Jpeg' that extents
// TGraphics to support '.jpg' and '.jpeg' files. 
interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, PBPreview, Jpeg;

type
	TForm1 = class(TForm)
		OpenButton: TButton;
		Label1: TLabel;
		SaveButton: TButton;
		PBOpenPreviewDialog1: TPBOpenPreviewDialog;
    PBSavePreviewDialog1: TPBSavePreviewDialog;
		procedure OpenButtonClick(Sender: TObject);
		procedure PBOpenPreviewDialog1Preview(Sender: TPBOpenPreviewDialog;
			Ext: String);
		procedure SaveButtonClick(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		function LocaleText(List : TStrings) : string;
	private
		{ Private declarations }
	public
		{ Public declarations }
	end;

var
	Form1: TForm1;
	OpenText, SaveText, LabelText : TStrings;
	
implementation

{$R *.DFM}

procedure TForm1.OpenButtonClick(Sender: TObject);
begin
	PBOpenPreviewDialog1.Execute;
end;

procedure TForm1.SaveButtonClick(Sender: TObject);
begin
	PBSavePreviewDialog1.Execute;
end;

procedure TForm1.PBOpenPreviewDialog1Preview(Sender: TPBOpenPreviewDialog; Ext: String);
var
	F : textfile;
	Linex, X1, Y1, X2, Y2 : string;
begin
	with Sender do
	begin
		if Ext = 'xxx' then
		begin
			try
				AssignFile(F, FileName);
				Reset(F);
				ReadLn(F, Linex);
				if Linex = '[Preview]' then
				begin
					ReadLn(F, Linex);
					Repeat
						PreviewText.Lines.Add(Linex);
						ReadLn(F, Linex);
					until (Linex = '[data]') or eof(F);
				end;
			finally
				CloseFile(F);
			end;
		end
		else if Ext = 'yyy' then
		begin
			try
				AssignFile(F, FileName);
				Reset(F);
				ReadLn(F, X1);
				ReadLn(F, Y1);
				ReadLn(F, X2);
				ReadLn(F, Y2);
				with PreviewImage.Picture.Bitmap do
				begin
					Width := 320;
					Canvas.Brush.Color := clBlue;
					Canvas.Ellipse(strtoint(X1), strtoint(Y1), strtoint(X2), strtoint(Y2));
				end;
			finally
				CloseFile(F);
			end;
		end
		else if Ext = 'zzz' then
		begin
			PreviewText.Lines.LoadFromFile(FileName);
		end;
	end;
end;

{This is the function that is used to localize the captions and hints in PBOpen-
PreviewDialog. You may use the idea and the function if you want(Public domain).
It is good when only a few strings have to be localized or when you won't have
any external files. (You don't have to include this in your project to use
PBPreviewDialogs, the unit has its own function).
Of course if your preview is language-dependent you can use it.}
function TForm1.LocaleText(List : TStrings) : string;
var
	FLocale : string;
begin
	FLocale := IntToHex(GetUserDefaultLangID, 4);
	if List.Count = 0 then Result := ''
	else
	begin
		if List.IndexOfName(FLocale) <> -1 then Result := List.Values[FLocale]
		else if List.IndexOfName('Default') <> -1 then Result := List.Values['Default']
		else Result := List.Values[List.Names[0]];
	end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	OpenText := TStringList.Create;
	OpenText.CommaText := 'Default=Open, 0406=bn, 0407=ffnen, 040C=Ouvrir, 0413=Open';
	SaveText := TStringList.Create;
	SaveText.CommaText := '"Default=Save as", "0406=Gem som", '
	+ '0407="Speichern unter", 040C=Enregistrer, "0413=Opslaan als"';
	LabelText := TStringList.Create;
	LabelText.CommaText := '"Default=Choose the file ''File.xxx'' or ' +
		'''File.yyy'' to see custom previews.", "0406=Vlg filen ''File.xxx'' eller ' +
		'''File.yyy'' for at se brugerdefinerede prvevisninger", ' +
		'"0407=Whlen Sie bitte ''File.xxx'' oder ''File.yyy'' um die benutzer-definierte ' +
		'Vorschau zu sehen","040C=Choisissez ''File.xxx'' ou ''File.yyy'' pour voir ' +
		'les preuves disponibles", "0413=Kies het bestand ''File.xxx'' of ''File.yyy''' +
		' om voorbeelden van bijzondere bestandstypen te zien"';
	OpenButton.Caption := LocaleText(OpenText);
	SaveButton.Caption := LocaleText(SaveText);
	Label1.Caption := LocaleText(LabelText);
end;

end.

