unit DemoUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FindFile, StdCtrls;

type
  TForm1 = class(TForm)
    StartBtn: TButton;
    AbortBtn: TButton;
    List: TMemo;
    StatusLbl: TLabel;
    FindFile1: TFindFile;
    OkBtn: TButton;
    WhatList: TMemo;
    Label2: TLabel;
    StLbl: TLabel;
    Label1: TLabel;
    WhereList: TMemo;
    OKBtn2: TButton;
    Label3: TLabel;
    procedure StartBtnClick(Sender: TObject);
    procedure AbortBtnClick(Sender: TObject);
    procedure FindFile1Start(Sender: TObject);
    procedure FindFile1Abort(Sender: TObject);
    procedure FindFile1Found(const fName, fPath: String);
    procedure FindFile1Done(Sender: TObject);
    procedure FindFile1ScanDirsDone(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.StartBtnClick(Sender: TObject);
begin
  FindFile1.Start;
end;

procedure TForm1.AbortBtnClick(Sender: TObject);
begin
  FindFile1.Abort;
end;

procedure TForm1.FindFile1Start(Sender: TObject);
begin
  List.Clear;
  StatusLbl.Caption := 'Scanning directory structure...';
  OkBtn.Enabled := false;
  OkBtn2.Enabled := false;
  AbortBtn.Enabled := true;
end;

procedure TForm1.FindFile1Abort(Sender: TObject);
begin
  StatusLbl.Caption := 'Aborted.';
  OkBtn.Enabled := true;
  OkBtn2.Enabled := true;
  AbortBtn.Enabled := false;
end;

procedure TForm1.FindFile1Found(const fName, fPath: String);
begin
  List.Lines.Add(fPath+fName);
end;

procedure TForm1.FindFile1Done(Sender: TObject);
begin
  StatusLbl.Caption := 'Done.';
  OkBtn.Enabled := true;
  OkBtn2.Enabled := true;
  AbortBtn.Enabled := false;
end;

procedure TForm1.FindFile1ScanDirsDone(Sender: TObject);
begin
  StatusLbl.Caption := 'Searching for files...';
end;

procedure TForm1.OkBtnClick(Sender: TObject);
begin
  FindFile1.FilesToFind.Assign(WhatList.Lines);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FindFile1.FilesToFind.Assign(WhatList.Lines);
  FindFile1.StartDirs.Assign(WhereList.Lines);
end;

end.
