// Defines and settings for BakSoft-Denmark's components.
// Defines are made by the logic: "You know the past, you don't know
// the future. Best guess: The future will be like the present."
// New compiler versions will use the largest defined settings, 
// so unless specific changes prevents it, it will still compile!

{$BOOLEVAL OFF}
{$EXTENDEDSYNTAX ON}
{$IMPORTEDDATA ON}
{$LONGSTRINGS ON}
{$OPENSTRINGS ON}
{$TYPEDADDRESS OFF}
{$VARSTRINGCHECKS OFF}
{$WRITEABLECONST OFF}

{$UNDEF DELPHI}
{$UNDEF DEL_MAX_3}
{$UNDEF DEL_MAX_4}
{$UNDEF DEL_MAX_5}
{$UNDEF DEL_MAX_6}
{$UNDEF DEL_MAX_7}
{$UNDEF COMPILER_MAX_3}
{$UNDEF COMPILER_MAX_4}
{$UNDEF COMPILER_MAX_5}
{$UNDEF COMPILER_MAX_6}
{$UNDEF COMPILER_MAX_7}
{$UNDEF BCB_MAX_3}
{$UNDEF BCB_MAX_4}
{$UNDEF BCB_MAX_5}
{$UNDEF BCB_MAX_6}
{$UNDEF BCB_MAX_7}

{$IFDEF VER100}
	{$DEFINE DEL_MAX_3}
	{$DEFINE DEL_MAX_4}
	{$DEFINE DEL_MAX_5}
	{$DEFINE DEL_MAX_6}
	{$DEFINE DEL_MAX_7}
	{$DEFINE COMPILER_MAX_3}
	{$DEFINE COMPILER_MAX_4}
	{$DEFINE COMPILER_MAX_5}
	{$DEFINE COMPILER_MAX_6}
	{$DEFINE COMPILER_MAX_7}
{$ENDIF}


{$IFDEF VER110}
	{$DEFINE BCB}
	{$DEFINE BCB_MAX_3}
	{$DEFINE BCB_MAX_4}
	{$DEFINE BCB_MAX_5}
	{$DEFINE BCB_MAX_6}
	{$DEFINE BCB_MAX_7}
	{$DEFINE COMPILER_MAX_3}
	{$DEFINE COMPILER_MAX_4}
	{$DEFINE COMPILER_MAX_5}
	{$DEFINE COMPILER_MAX_6}
	{$DEFINE COMPILER_MAX_7}
{$ENDIF}

{$IFDEF VER120}
	{$DEFINE DEL_MAX_4}
	{$DEFINE DEL_MAX_5}
	{$DEFINE DEL_MAX_6}
	{$DEFINE DEL_MAX_7}
	{$DEFINE COMPILER_MAX_4}
	{$DEFINE COMPILER_MAX_5}
	{$DEFINE COMPILER_MAX_6}
	{$DEFINE COMPILER_MAX_7}
{$ENDIF}


{$IFDEF VER125}
	{$DEFINE BCB}
	{$DEFINE BCB_MAX_4}
	{$DEFINE BCB_MAX_5}
	{$DEFINE BCB_MAX_6}
	{$DEFINE BCB_MAX_7}
	{$DEFINE COMPILER_MAX_4}
	{$DEFINE COMPILER_MAX_5}
	{$DEFINE COMPILER_MAX_6}
	{$DEFINE COMPILER_MAX_7}
{$ENDIF}

{$IFDEF VER130}
	{$DEFINE COMPILER_MAX_5}
	{$DEFINE COMPILER_MAX_6}
	{$DEFINE COMPILER_MAX_7}
	{$IFDEF BCB}
		{$DEFINE BCB_MAX_5}
		{$DEFINE BCB_MAX_6}
		{$DEFINE BCB_MAX_7}
	{$ELSE}
		{$DEFINE DEL_MAX_5}
		{$DEFINE DEL_MAX_6}
		{$DEFINE DEL_MAX_7}
	{$ENDIF}
{$ENDIF}

{$IFDEF VER140}
	{$DEFINE COMPILER_MAX_6}
	{$DEFINE COMPILER_MAX_7}
	{$IFDEF BCB}
		{$DEFINE BCB_MAX_6}
		{$DEFINE BCB_MAX_7}
	{$ELSE}
		{$DEFINE DEL_MAX_6}
		{$DEFINE DEL_MAX_7}
	{$ENDIF}
{$ENDIF}

{$IFDEF VER150}
	{$DEFINE COMPILER_MAX_7}
	{$IFDEF BCB}
		{$DEFINE BCB_MAX_7}
	{$ELSE}
		{$DEFINE DEL_MAX_7}
	{$ENDIF}
{$ENDIF}

{$IFNDEF COMPILER_MAX_5}
	{$WARN SYMBOL_DEPRECATED OFF}
	{$WARN SYMBOL_PLATFORM OFF}
{$ENDIF}

{$IFDEF BCB}
	 {$ObjExportAll On}
{$ELSE}
	{$DEFINE DELPHI}
{$ENDIF}
